jQuery.sap.require("sap.ui.core.routing.Router");
jQuery.sap.require("sas.risk.common.models.RiskJSONModel");
jQuery.sap.require("sas.stress.models.ModelGroupRunAPI");
jQuery.sap.require("sas.stress.wkbench.model.CellRef");
jQuery.sap.require("sas.stress.wkbench.StressFixes");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.UserPrefs");
jQuery.sap.require("sas.stress.wkbench.widget.SlimsheetSource");

sas.stress.wkbench.ViewManager = {
    _router: sap.ui.core.routing.Router.getRouter("router"),
    // the list of scenario editors that are created for later destruction
    _scenarioEditorViews: {},
    // getProjectManager: function () {
    //     return sap.ui.getCore().byId("sasstress");//from index.jsp
    // },
    getHomePage: function () {
        return sap.ui.getCore().byId("HomePageView");
    },
    getWorkbench: function () {
        return sap.ui.getCore().byId("WorkbenchView");
    },
    getProjectReportsEditor: function () {
        return sap.ui.getCore().byId("ProjectReportsEditorView");
    },
    getConfiguration: function () {
        return sap.ui.getCore().byId("ConfigurationView");
    },
    getBrowseModelInventory: function () {
        return sap.ui.getCore().byId("BrowseModelInventoryView");
    },
    getInventoryModelDetails: function () {
        return sap.ui.getCore().byId("InventoryModelDetailsView");
    },
    getProjectConfiguration: function () {
        return sap.ui.getCore().byId("ProjectConfigurationView");
    },
    getHierarchyMapping: function () {
        return sap.ui.getCore().byId("HierarchyMappingView");
    },
    getDataEditor: function () {
        return sap.ui.getCore().byId("DataEditorView");
    },
    getProjectDataEditor: function () {
        return sap.ui.getCore().byId("ProjectDataEditorView");
    },
    // getLoadDataEditor: function () {
    //     return sap.ui.getCore().byId("LoadDataEditorView");
    // },
    // getLoadProjectDataEditor: function () {
    //     return sap.ui.getCore().byId("LoadProjectDataEditorView");
    // },
    getScenarioComparisonEditor: function (sheet) {
        return sap.ui.getCore().byId("ScenarioEditorComparisonView_" + sheet.getId());
    },
    getScenarioEditor: function (sheetId, filterId, iterationId) {
        return sap.ui.getCore().byId("ScenarioEditorView_" + sheetId + "_" + filterId + "_" + iterationId);
    },
    getFilingPackageView: function () {
        return sap.ui.getCore().byId("PackagePageView");
    },
    // getAddScenarios: function () {
    //     return sap.ui.getCore().byId("AddScenariosView");
    // },
    getModels: function () {
        return sap.ui.getCore().byId("ModelManagerView");
    },
    getModelGroupRuns: function () {
        return sap.ui.getCore().byId("ModelGroupRunsView");
    },
    // getModelGroupRunsCreateView: function () {
    //     return sap.ui.getCore().byId("ModelGroupRunsCreateView");
    // },
    getScenarioPage: function () {
        return sap.ui.getCore().byId("ScenarioPageView");
    },
    getGlobalScenarioPage: function () {
        return sap.ui.getCore().byId("GlobalScenarioPageView");
    },
    getCellEditor: function () {
        return sap.ui.getCore().byId("CellEditorView");
    },
    getCellCommentEditor: function (cellRef) {
        return sap.ui.getCore().byId("CellCommentEditorView_" + cellRef.toIdString(sas.stress.wkbench.model.CellRef.FMT_CELL_DIVID));
    },
    getScenarioEditorView: function (sheetId, filterId, iterationId) {
        return sap.ui.getCore().byId("ScenarioEditorView_" + sheetId + "_" + filterId + "_" + iterationId);
    },
    getCreateWorksheetTemplateEditor: function () {
        return sap.ui.getCore().byId("CreateWorksheetTemplateEditorView");
    },
    getCreateDimensionEditor: function () {
        return sap.ui.getCore().byId("CreateDimensionEditorView");
    },
    getCreateDataCrossingEditor: function () {
        return sap.ui.getCore().byId("CreateDataCrossingEditorView");
    },
    // getHierarchyMappingEditor: function () {
    //     return sap.ui.getCore().byId("HierarchyMappingView");
    // },
    getSheetTemplateManager: function () {
        return sap.ui.getCore().byId("SheetTemplateManagerView");
    },
    getProcessDefinitions: function () {
        return sap.ui.getCore().byId("ProcessDefinitionsView");
    },
    getLogDialogView: function () {
        return sap.ui.getCore().byId("LogDialogView");
    },
    getConflictDialogView: function () {
        return sap.ui.getCore().byId("ConflictDialogView");
    },
    getModelGroups: function () {
        return sap.ui.getCore().byId("ModelGroupsView");
    },
    getScriptManager: function () {
        return sap.ui.getCore().byId("ScriptManagerView");
    },
    getCreateModelGroup: function () {
        //return sap.ui.getCore().byId("CreateModelGroupView");
        return sap.ui.getCore().byId("ModelGroupDetailsView");
    },
    getCreateScript: function () {
        return sap.ui.getCore().byId("ScriptDetailsView");
    },
    getAddModelsForGroupDialogView: function () {
        return sap.ui.getCore().byId("AddModelsView");
    },
    getModelDetailsForGroupDialogView: function () {
        return sap.ui.getCore().byId("CommonModelDetailsView");
    },
    getVariablesForModelGroupDialogView: function () {
        return sap.ui.getCore().byId("VariablesView");
    },
    getCommonModelDetailsView:function(){
        return sap.ui.getCore().byId("CommonModelDetailsView");
    },
    getExecutionLogDialogView : function() {
        return sap.ui.getCore().byId("ExecutionLogView");
    },
    getTaskSASScriptParameters:function(){
        return sap.ui.getCore().byId("TaskSASScriptParametersView");
    },
    getArchiveManager: function () {
        return sap.ui.getCore().byId("ArchiveManagerView");
    },
    getDimensionManager: function () {
        return sap.ui.getCore().byId("DimensionManagerView");
    },
    getDataCrossingManager: function () {
        return sap.ui.getCore().byId("DataCrossingManagerView");
    },
    getCreateArchive: function () {
        return sap.ui.getCore().byId("CreateArchiveView");
    },
    getUserManager: function () {
        return sap.ui.getCore().byId("UserManagerView");
    },
    getNotificationPage: function () {
        return sap.ui.getCore().byId("NotificationPageView");
    },
    getEditScriptParameterView: function () {
        return sap.ui.getCore().byId("EditScriptParameterView");
    },
    loadProjectManager: function () {
        var currentHash = sas.stress.wkbench.ViewManager._router.getHash();
        if (currentHash && currentHash.indexOf("ProjectManager") >= 0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("ProjectManager", null, false);
    },
    loadHomePage: function (project) {
        sas.stress.wkbench.UserPrefs.save("sas.stress.wkbench.project_key", project.getId());
        var homePage = sas.stress.wkbench.ViewManager.getHomePage();
        if (homePage) {
            var currentHash = sas.stress.wkbench.ViewManager._router.getHash();
            if (currentHash && currentHash.indexOf("Home") >= 0) {
                return;
            }
            homePage.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("HomePage", { projectId: project.getId() }, false);
    },
    loadWorkbench: function (project, params) {
        var workbenchView = sas.stress.wkbench.ViewManager.getWorkbench();
        if (workbenchView) {
            var currentHash = sas.stress.wkbench.ViewManager._router.getHash();
            if (currentHash && currentHash.indexOf("Workbench") >= 0) {
                return;
            }
            workbenchView.destroy();
        }
        // If params were specified, then put them into a JSON model, otherwise set the model to undefined.
        if (params) {
            var model = new sas.risk.common.models.RiskJSONModel();
            model.setData(params);
            sap.ui.getCore().setModel(model, "WorkbenchParams");
        } else {
            sap.ui.getCore().setModel(undefined, "WorkbenchParams");
        }

        this.projectName=project.getName();
        sas.stress.wkbench.ViewManager._router.navTo("Workbench", { projectId: project.getId() }, false);
    },
    loadSheetTemplateManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.SheetTemplateManager", viewData);
    },
    loadProcessDefinitions: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.ProcessDefinitions", viewData);
    },
    loadProjectReportsEditor: function (project) {
        var projectReportsEditor = sas.stress.wkbench.ViewManager.getProjectReportsEditor();
        if (projectReportsEditor) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Reports") >= 0) {
                return;
            }
            projectReportsEditor.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("Reports", { projectId: project.getId() }, false);
    },
    loadProjectReportsCreate: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "CreateReportParams");

        sas.stress.wkbench.ViewManager.loadProjectReportsEditor(project);
    },
    loadProjectReportsRun: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "RunReportParams");

        sas.stress.wkbench.ViewManager.loadProjectReportsEditor(project);
    },
    loadConfiguration: function (viewData) {
        var configuration = sas.stress.wkbench.ViewManager.getConfiguration();
        if (configuration) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Configuration") >= 0) {
                return;
            }
            //configuration.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("Configuration", {}, false);
    },
    loadDataEditor: function (viewData) {
        var data = sas.stress.wkbench.ViewManager.getDataEditor();
        if (data) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Data") >= 0  && currenthash.indexOf("Project/")!==0) {
                return;
            }
            data.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("Data", {}, false);
    },
    loadModelsBrowser: function (viewData) {
        var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
        if (currenthash && currenthash.indexOf("Models") >= 0 && currenthash.indexOf("Models/") !== 0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("BrowseModelInventory", {}, false);
        // return sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.browse.BrowseModelInventory", viewData);
    },
    loadModelsDetails: function (viewData) {
        //This is called when you select a row from Models briswing page
        var data = sas.stress.wkbench.ViewManager.getInventoryModelDetails();
        if (data) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("InventoryModelDetails") >= 0) {
                return;
            }
            data.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("InventoryModelDetails", {modelId: viewData}, false);
        //return sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.browse.InventoryModelDetails", {modelId: viewData});
    },
    loadHierarchyMappingEditor: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.HierarchyMapping", viewData);
    },
    loadGlobalScenarioPage: function (viewData) {
        var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
        if (currenthash && currenthash.indexOf("Scenarios") >= 0 && currenthash.indexOf("Project/")!==0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("GlobalScenarioPage", {}, false);
    },
    loadProjectConfiguration: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.ProjectConfiguration", viewData);
    },
    loadProjectDataEditor: function (project) {
        var projectDataEditor = sas.stress.wkbench.ViewManager.getProjectDataEditor();
        if (projectDataEditor) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Data") >= 0) {
                return;
            }
            projectDataEditor.destroy();
        }

        sas.stress.wkbench.ViewManager._router.navTo("ProjectData", { projectId: project.getId() }, false);
    },
    loadProjectDataEditorLoadData: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "ProjectDataParams");

        sas.stress.wkbench.ViewManager.loadProjectDataEditor(project);
    },
    loadLoadDataEditor: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.data.view.LoadDataEditor", viewData);
    },
    loadLoadProjectDataEditor: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.data.view.LoadProjectDataEditor", viewData);
    },
    loadFilingPackagePage: function (project) {
        var filingPackage = sas.stress.wkbench.ViewManager.getFilingPackageView();
        if (filingPackage) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Packages") >= 0) {
                return;
            }
            filingPackage.destroy();
        }

        sas.stress.wkbench.ViewManager._router.navTo("PackagePage", { projectId: project.getId() }, false);
    },
    loadProjectPackagesCreate: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "CreatePackageParams");

        sas.stress.wkbench.ViewManager.loadFilingPackagePage(project);
    },
    loadProjectPackagesValidate: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "ValidatePackageParams");

        sas.stress.wkbench.ViewManager.loadFilingPackagePage(project);
    },
    loadScenarioPage: function (project) {
        var scenarioPage = sas.stress.wkbench.ViewManager.getScenarioPage();
        if (scenarioPage) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Scenarios") >= 0) {
                return;
            }
            scenarioPage.destroy();
        }

        sas.stress.wkbench.ViewManager._router.navTo("ScenarioPage", { projectId: project.getId() }, false);
    },
    loadScenarioPageAdd: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "AddScenariosParams");

        sas.stress.wkbench.ViewManager.loadScenarioPage(project);
    },
    loadScenarioPageImport: function (project, params) {
        var model = new sas.risk.common.models.RiskJSONModel();
        model.setData(params);
        sap.ui.getCore().setModel(model, "ImportScenariosParams");

        sas.stress.wkbench.ViewManager.loadScenarioPage(project);
    },
    loadAddScenariosView: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.scenarios.view.AddScenarios", viewData);
    },

    //loadModelsBrowser: function (viewData) {
    //    return sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.browse.BrowseModelInventory", viewData);
    //},



    loadModelGroupRuns: function (project) {
        var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
        if (currenthash && currenthash.indexOf("ModelGroupRunsManager") >= 0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("ModelGroupRunsManager", { projectId: project.getId() }, false);
    },
    loadModelGroupRunsCreate: function (project) {
        sas.stress.models.ModelGroupRunAPI.loadModelGroupRunsCreateArtifacts(
            project.getId(),
            function () {
                sas.stress.wkbench.ViewManager._router.navTo("ModelGroupRunsCreate", { projectId: project.getId() }, false);
            },
            function (jqXHR) {
                sas.stress.wkbench.StressUtil.handleServerFailure(jqXHR);
            }
        );
    },
    loadModelGroupRunsSensitivity: function (project, scenarioId, runIds, howToRun, workGroup) {
        sas.stress.models.ModelGroupRunAPI.loadModelGroupRunsSensitivityArtifacts(
            project,
            scenarioId,
            runIds,
            howToRun,
            workGroup,
            function () {
                sas.stress.wkbench.ViewManager._router.navTo("ModelGroupRunsSensitivity", {projectId: project.getId()}, false);
            },
            function (jqXHR) {
                sas.stress.wkbench.StressUtil.handleServerFailure(jqXHR);
            }
        );
    },
    loadCellEditor: function () {
        var cellEditorView = sas.stress.wkbench.ViewManager.getCellEditor();
        if (!cellEditorView) {
            cellEditorView = sap.ui.view("CellEditorView", {
                height: '100%',
                width: '100%',
                viewName: 'sas.stress.wkbench.view.CellEditor',
                type: sap.ui.core.mvc.ViewType.JS
            });
        }
        sas.stress.wkbench.ViewManager.getWorkbench().setCellEditorView(cellEditorView);
    },
    loadCellCommentEditor: function (cellRef, bShowCommentField, bshowValidation) {
        var cellCommentEditorView = sas.stress.wkbench.ViewManager.getCellCommentEditor(cellRef);
        var viewData = { cellRef: cellRef, showCommentField: bShowCommentField, showValidation: bshowValidation };
        if (!cellCommentEditorView) {
            cellCommentEditorView = sap.ui.view("CellCommentEditorView_" + cellRef.toIdString(sas.stress.wkbench.model.CellRef.FMT_CELL_DIVID), {
                height: '100%',
                width: '100%',
                viewName: 'sas.stress.wkbench.view.CellCommentEditor',
                type: sap.ui.core.mvc.ViewType.JS,
                viewData: viewData
            });
        } else {
            cellCommentEditorView.oViewData = viewData;
        }
        return cellCommentEditorView;
    },
    loadNewProjectIteration: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.wkbench.view.NewProjectIteration", viewData);
    },
    loadWorksheetImport: function () {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.wkbench.view.WorksheetImport");
    },
    loadScenarioComparisonEditor: function (sheet, comparisonId) {
        var scenarioView = sas.stress.wkbench.ViewManager.getScenarioComparisonEditor(sheet);
        if (scenarioView) {
            scenarioView.destroy();
            scenarioView = null;
        }
        var project = sheet.getProject();
        var scenarios = [];
        var defs = [];
        _.each(project.getSheets(), function (s) {
            _.each(comparisonId.split(":"), function (sId) {
                var scenario = s.getSheetScenario(sId);
                if (!scenario.getData()) {
                    scenarios.push(scenario);
                    defs.push(scenario.loadCellData());
                }
            });
        });
        $.when.apply($, defs).done(function () {
            var i;
            for (i = 0; i < scenarios.length; i++) {
                scenarios[i].getData().processOverlays();//evaluate all the formulas
            }
            scenarioView = sap.ui.view("ScenarioEditorComparisonView_" + sheet.getId(), {
                height: '100%',
                width: '100%',
                viewName: 'sas.stress.wkbench.view.ScenarioEditor',
                type: sap.ui.core.mvc.ViewType.JS,
                viewData: {
                    sheetId: sheet.getId(),
                    scenarioId: comparisonId,
                    sourceClass: sas.stress.wkbench.widget.SlimsheetCompareSource
                }
            });
            sas.stress.wkbench.ViewManager.getWorkbench().getModel("live").setProperty("/previousSheetId", sheet.getId());
            sas.stress.wkbench.ViewManager.getWorkbench().getModel("live").setProperty("/previousScenarioId", "compare");
            sas.stress.wkbench.ViewManager.getWorkbench().setScenarioEditorView(scenarioView);
        });
    },
    loadScenarioEditor: function (sheetId, filterId, iterationId) {
        // destroy existing scenarioView from the workbench
        var scenarioView = sas.stress.wkbench.ViewManager.getScenarioEditorView(sheetId, filterId, iterationId);
        if (scenarioView) {
            scenarioView.getController()._updateFiltersDisplay();
            //scenarioView.destroy(); // do not do this for now
        }
        scenarioView = sas.stress.wkbench.ViewManager.getScenarioEditor(sheetId, filterId, iterationId);
        if (!scenarioView) {
            scenarioView = sap.ui.view("ScenarioEditorView_" + sheetId + "_" + filterId + "_" + iterationId, {
                height: '100%',
                width: '100%',
                viewName: 'sas.stress.wkbench.view.ScenarioEditor',
                type: sap.ui.core.mvc.ViewType.JS,
                viewData: {
                    sheetId: sheetId,
                    filters: filterId,
                    iterationId: iterationId,
                    sourceClass: sas.stress.wkbench.widget.SlimsheetSource
                }
            });
            scenarioView.addStyleClass("stressScenarioEditorLayout");
            // store this.. we be queried when the workbench is being destroyed...
            this._scenarioEditorViews["ScenarioEditorView_" + sheetId + "_" + filterId + "_" + iterationId] = scenarioView;
        }
        sas.stress.wkbench.ViewManager.getWorkbench().setScenarioEditorView(scenarioView);
    },
    loadSheetCategoryEditor: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.SheetCategoryEditor", viewData);
    },
    loadCreateWorksheetTemplateEditor: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.CreateWorksheetTemplateEditor", viewData);
    },

    loadCreateDataCrossing: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.crossing.view.CreateDataCrossingEditor", viewData);
    },

    loadCreateDimension: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.CreateDimensionEditor", viewData);
    },

    createModelGroupEditor: function (viewData) {
        var modelGroup = sas.stress.wkbench.ViewManager.getCreateModelGroup();
        if (modelGroup) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("ModelGroupDetails") >= 0) {
                return;
            }
            modelGroup.destroy();
        }
        //sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.groups.CreateModelGroup", viewData);
        sas.stress.wkbench.ViewManager._router.navTo("ModelGroupDetails", {modelGroupId: 0}, false);
    },
    loadModelGroupEditor: function (viewData) {
        var modelGroup = sas.stress.wkbench.ViewManager.getCreateModelGroup();
        if (modelGroup) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("ModelGroupDetails") >= 0) {
                return;
            }

            modelGroup.destroy();
        }
        // sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.groups.CreateModelGroup", viewData);
        sas.stress.wkbench.ViewManager._router.navTo("ModelGroupDetails", { modelGroupId: viewData }, false);
    },
    loadScriptEditor: function (viewData) {
        var script = sas.stress.wkbench.ViewManager.getCreateScript();
        if (script) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("ScriptDetails") >= 0) {
                return;
            }
            script.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("ScriptDetails", { scriptId: viewData }, false);
    },
    _loadView: function (viewName, viewData) {
        var shortName = viewName.substring(viewName.lastIndexOf(".") + 1);
        var fnName = "get" + shortName;
        var view;
        if (sas.stress.wkbench.ViewManager[fnName] !== undefined) {
            view = sas.stress.wkbench.ViewManager[fnName]();
        }
        if (view === undefined) {
            view = sap.ui.view(shortName + "View", {
                height: '100%',
                width: '100%',
                viewName: viewName,
                type: sap.ui.core.mvc.ViewType.JS,
                viewData: viewData
            });
        }

        return view;
    },
    loadLogDialogView: function () {
        var logDialogView = sas.stress.wkbench.ViewManager.getLogDialogView();
        if (logDialogView) {
            logDialogView.destroy();
        }
        //if (!logDialogView){
        logDialogView = sap.ui.view("LogDialogView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.wkbench.view.LogDialog',
            type: sap.ui.core.mvc.ViewType.JS
        });
        //}
        return logDialogView;
    },
    loadConflictDialogView: function (project, freshProject, conflicts, updatedByUser) {
        var conflictDialogView = sas.stress.wkbench.ViewManager.getConflictDialogView();
        if (conflictDialogView) {
            conflictDialogView.destroy();
        }
        var viewdata = {
            project: project,
            freshProject: freshProject,
            conflicts: conflicts,
            updatedByUser: updatedByUser
        };
        conflictDialogView = sap.ui.view("ConflictDialogView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.wkbench.view.ConflictProjectDialog',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewdata
        });
        return conflictDialogView;
    },
    loadExecutionLogDialogView: function (name, status, executionLog, rb) {
        var executionLogDialogView = sas.stress.wkbench.ViewManager.getExecutionLogDialogView();
        if (executionLogDialogView) {
            executionLogDialogView.destroy();
        }
        //if (!logDialogView){
        var viewData = { name: name, errors: 0, status: status, executionLog: executionLog, rb: rb };
        executionLogDialogView = sap.ui.view("ExecutionLogView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.wkbench.view.ExecutionLog',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewData
        });
        //}
        return executionLogDialogView;
    },
    loadScriptsView: function (viewData) {
        var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
        if (currenthash && currenthash.indexOf("Scripts") >= 0 && currenthash.indexOf("Scripts/") !== 0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("Scripts", {}, false);
    },
    loadModelGroupsView: function (viewData) {
        var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
        if (currenthash && currenthash.indexOf("ModelGroups") >= 0 && currenthash.indexOf("ModelGroups/") !== 0) {
            return;
        }
        sas.stress.wkbench.ViewManager._router.navTo("ModelGroups", null, false);
    },
    loadAddModelsForGroupDialogView: function (mdlGrpController, interval, selectedModelIds, rb) {
        var addModelsDialogView = sas.stress.wkbench.ViewManager.getAddModelsForGroupDialogView();
        if (addModelsDialogView) {
            addModelsDialogView.destroy();
        }
        var viewData = {
            mdlGrpController: mdlGrpController,
            interval: interval,
            existingModelIds: selectedModelIds,
            rb: rb
        };
        addModelsDialogView = sap.ui.view("AddModelsView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.models.view.groups.AddModels',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewData
        });
        return addModelsDialogView;
    },
    loadModelDetailsForGroupDialogView: function (selectedModelId, rb) {
        var detailsModelDialogView = sas.stress.wkbench.ViewManager.getModelDetailsForGroupDialogView();
        if (detailsModelDialogView) {
            detailsModelDialogView.destroy();
        }
        var viewData = {
            modelId: selectedModelId,
            rb: rb
        };
        detailsModelDialogView = sap.ui.view("CommonModelDetailsView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.models.view.browse.CommonModelDetails',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewData
        });
        return detailsModelDialogView;
    },
    loadAddVariablesForGroupDialogView: function (modelGroup, rb, classAndoutputVars, existinghierarchies) {
        var addVarsDialogView = sas.stress.wkbench.ViewManager.getVariablesForModelGroupDialogView();
        if (addVarsDialogView) {
            addVarsDialogView.destroy();
        }
        var isCreate = true;
        if (classAndoutputVars) {
            isCreate = false;
        }
        var viewData = {
            modelGroup: modelGroup,
            rb: rb,
            data: classAndoutputVars,
            isCreate: isCreate,
            existinghierarchies: existinghierarchies
        };
        addVarsDialogView = sap.ui.view("VariablesView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.models.view.groups.Variables',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewData
        });
        return addVarsDialogView;
    },
    loadEditScriptParameterView: function (existingParameter, parametersJSON) {
        var editScriptParameterView = sas.stress.wkbench.ViewManager.getEditScriptParameterView();
        if (editScriptParameterView) {
            editScriptParameterView.destroy();
        }
        var viewData = {
            parameter: existingParameter,
            otherParameters: parametersJSON
        };
        editScriptParameterView = sap.ui.view("EditScriptParameterView", {
            height: '100%',
            width: '100%',
            viewName: 'sas.stress.scripts.view.EditScriptParameter',
            type: sap.ui.core.mvc.ViewType.JS,
            viewData: viewData
        });
        return editScriptParameterView;
    },
    getAllScenarioEditorViews: function () {
        return this._scenarioEditorViews;
    },
    loadCommonModelDetails:function(viewData){
        var view=sas.stress.wkbench.ViewManager.getCommonModelDetailsView();
        if (view){
            view.destroy();
        }
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.models.view.browse.CommonModelDetails", viewData);
    },
    loadTaskSASScriptParameters:function(viewData){
        var view=sas.stress.wkbench.ViewManager.getTaskSASScriptParameters();
        if (view){
            view.destroy();
        }
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.wkbench.view.TaskSASScriptParameters", viewData);
    },
    loadDataCrossingManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.crossing.view.DataCrossingManager", viewData);
    },
    loadDimensionManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.DimensionManager", viewData);
    },
    //loadArchiveManager: function (viewData) {
    //    var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
    //    if (currenthash && currenthash.indexOf("ArchiveManager") >= 0 && currenthash.indexOf("ArchiveManager/") !== 0) {
    //        return;
    //    }
    //    sas.stress.wkbench.ViewManager._router.navTo("ArchiveManager", {}, false);
    //},
    loadArchiveManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.archive.view.ArchiveManager", viewData);
    },
    //loadCreateArchive: function (viewData) {
    //    var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
    //    if (currenthash && currenthash.indexOf("CreateArchive") >= 0 && currenthash.indexOf("CreateArchive/") !== 0) {
    //        return;
    //    }
    //    sas.stress.wkbench.ViewManager._router.navTo("CreateArchive", {}, false);
    //},
    loadCreateArchive: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.archive.view.CreateArchive", viewData);
    },
    loadUserManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.config.view.UserManager", viewData);
    },
    loadImportArchive: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.archive.view.ImportArchive", viewData);
    },
    loadUploadArchive: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.archive.view.UploadArchive", viewData);
    },
    loadCreateNotification: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.notification.view.CreateNotification", viewData);
    },
    loadAddUserContacts: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.notification.view.AddUserContacts", viewData);
    },
    loadNotificationPage: function (project) {
        var notificationPage = sas.stress.wkbench.ViewManager.getNotificationPage();
        if (notificationPage) {
            var currenthash = /*sas.stress.wkbench.StressUtil*/sas.stress.wkbench.ViewManager._router.getHash();
            if (currenthash && currenthash.indexOf("Notifications") >= 0) {
                return;
            }
            notificationPage.destroy();
        }
        sas.stress.wkbench.ViewManager._router.navTo("NotificationPage", { projectId: project.getId() }, false);
    },
    loadNotificationManager: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.notification.view.NotificationManager", viewData);
    },
    loadNotificationViewer: function (viewData) {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.notification.view.NotificationViewer", viewData);
    },
    loadAddRemoveSheetTemplates: function() {
        return sas.stress.wkbench.ViewManager._loadView("sas.stress.wkbench.view.AddRemoveSheetTemplates", undefined);
    }
};