%let metaserver   =<MetadataHost> ;
%let metaport     = <MetadataPort>;
%let metarepository  =Foundation;
%let metapass        =<SASADM PASSWORD>;
%let sasconflev=<SAS CONFIG LEV PATH>;



/***DO NOT CHANGE BELOW***/
option nosource;
%let solution12byte=stresssvrc;
%let software_component_name=Risk Finance Wkbnch Svr Cfg;

/* %let metaserver      = %sysget(METADATAHOST);
%let metaport        = %sysget(METAPORT);
%let metarepository  = %sysget(METAREPOS);
%let metapass        = %sysget(SASADMPASS);
%let SASCONFLEV=%sysget(SASCONFLEV);*/

options metaserver="&metaserver."
metarepository="&metarepository."
metaport=&metaport.
metauser="sasadm@saspw"
metapass="&metapass.";



proc lua restart ;
submit; 
sas.set_quiet(true)
function get_prop_of_softcom(software_component_name,propname)
sas.submit([[ 
option nomprint; 
%let SoftwareCompName=@software_component_name@;
%let prop=@propname@;
data _null_;
    length val $1000;
    softwareComp="&SoftwareCompName.";
    prop="&prop.";
    val="";
    val = metadata_appprop(softwareComp,prop);
    sysrc=sysrc();
    sysmsg=sysmsg();
    /* put sysrc=;
    put sysmsg=;
    put val=;*/
	call symputx("value",val);
	call symputx("return_cd",sysrc);
run;
]],{software_component_name=software_component_name,propname=propname},nil,4)

local val=sas.symget("value")
local rc=sas.symget("return_cd")
return val,rc 


end

function createTempFile(multiLineStringCode,appendStatements)

sas.submit([[
filename file TEMP;
%let filePath = %sysfunc(pathname(file));
]],{},nil,4)

local tmpFile=sas.symget("filePath")
--print("tmpFile:: "..tmpFile)
local fileref =  sasxx.new("file")
local f = fileref:open("w")
f:write(multiLineStringCode)
f:write(appendStatements..'\n')
f:close()

return tmpFile

end 



local metahost=sas.symget("metaserver")
local metaport=sas.symget("metaport")
local metarepository=sas.symget("metarepository")
local sasadmpass=sas.symget("metapass")
local sasconflev=sas.symget("sasconflev")
local solution12byte=sas.symget("solution12byte")
local software_component_name=sas.symget("software_component_name")

local rfw_appdata,rfw_root_dir_rc=get_prop_of_softcom(software_component_name,"root.dir")
local rfw_prod_name,rfw_prod_name_rc=get_prop_of_softcom(software_component_name,'risk.work.group.dir.name')

local rwg_appdata,rwg_appdata_rc=get_prop_of_softcom('Risk Work Group Svr Cfg','root.dir')
local rwg_script_path,rwg_script_path_rc=get_prop_of_softcom('Risk Work Group Svr Cfg','root.applications.dir')

print("NOTE:rfw_appdata path=",rfw_appdata)
print("NOTE:rfw_prod_name=",rfw_prod_name)
print("NOTE:rwg_appdata=",rwg_appdata)
print("NOTE:rwg_script_path=",rwg_script_path)


local groovy=[[
proc groovy ;
add sasjar="ANT";
submit  "&metahost." "&metaport." "&metarepository."  "&sasadmpass."  "&solution12byte."  "&sasconflev." "&rfw_prod_name." "&rfw_appdata." "&rwg_appdata." "&rwg_script_path.";
import java.nio.file.*
import org.apache.tools.ant.*;



def  runCmdLine(commandToExecute,workingDirPath,fileNameWithPathforstdin=null) {

		println("NOTE:Executing Command ::"+commandToExecute)
		println("NOTE:Working Dir ::"+workingDirPath)
		println('NOTE:STDIN file::'+fileNameWithPathforstdin)
		
		def workdir=new File(workingDirPath);
		if (! workdir.exists()) {
			println('ERROR::'+workingDirPath+" doesn't exist")
		}
		try {
				ProcessBuilder pb=new ProcessBuilder()
				pb.redirectErrorStream(true);
				pb.command(commandToExecute)
				pb.directory(workdir)
				//println('Working DIr:::'+pb.directory())
				if (fileNameWithPathforstdin != null){
					def stdInFile=new File(fileNameWithPathforstdin)
					pb.redirectInput(stdInFile)
				}
				Process process=pb.start()

				BufferedReader stdInput = new BufferedReader(new InputStreamReader(process.getInputStream()))
				def s
				while ((s = stdInput.readLine()) != null) {
					println(s);
				}
				process.waitFor()
				return process.exitValue()
			} catch (Exception e) {
				e.printStackTrace()
			}

}

def (METADATAHOST,METAPORT,METAREPOSITORY,SASADMPASS,SOLUTION12BYTE,SASCONFLEV,PRODNAME,RFW_APPDATA,RWG_APPDATA1,RWG_SCRIPT_PATH1)= args;

SASCONFLEV=SASCONFLEV.replaceAll("\\\\","/")
RFW_APPDATA=RFW_APPDATA.replaceAll("\\\\","/")
RWG_APPDATA1=RWG_APPDATA1.replaceAll("\\\\","/")
RWG_SCRIPT_PATH1=RWG_SCRIPT_PATH1.replaceAll("\\\\","/")

def RFW_APPDATA_WG_PATH="$RFW_APPDATA/work_groups/"
def RWG_APPDATA="$RWG_APPDATA1/groups/"
def RWG_PUBLIC_PATH="$RWG_APPDATA/Public/$PRODNAME/"
def RWG_SCRIPT_PATH="$RWG_SCRIPT_PATH1/scripts/"


println "NOTE::###STARTED : Migrating Public Workgroup###"
println "NOTE::Copying $RFW_APPDATA into RiskWorkGroup Public ::$RWG_PUBLIC_PATH ..."
new AntBuilder().copy(todir: RWG_PUBLIC_PATH) {
        fileset(dir : RFW_APPDATA) {
              exclude(name:"**/work_groups/**")
              exclude(name:"**/backup*/**") 
			  exclude(name:"**/samples/**")
   }
}




def RWG_COMMAND="-metaserver $METADATAHOST -metaport $METAPORT -metauser sasadm@saspw -metapass $SASADMPASS -solutions $SOLUTION12BYTE"
if (System.properties['os.name'].toLowerCase().contains('windows')) {
RWG_COMMAND="$RWG_SCRIPT_PATH/create_work_group.cmd $RWG_COMMAND"
}else {
RWG_COMMAND="$RWG_SCRIPT_PATH/create_work_group.sh $RWG_COMMAND"
}

def oldPublicDir = new File(RFW_APPDATA_WG_PATH + "/Public");
if (!oldPublicDir.exists()) {
println("Creating Public directory to force migration later")
oldPublicDir.mkdir();
}

def baseDir = new File(RFW_APPDATA_WG_PATH)
if (baseDir.exists() && baseDir.isDirectory()) {
files = baseDir.listFiles()
if (files.size()) {
files.each {
if (it.isDirectory()){
/* println (it.getPath() + ' ' + it.getName())*/
def dirPath=it.getPath()
def dirName=it.getName()
def FINAL_RWG_COMMAND="$RWG_COMMAND -name $dirName"
def arr=FINAL_RWG_COMMAND.split(' ')
println("NOTE::Creating Workgroup::" +  dirName)
println('')

runCmdLine(arr,RWG_SCRIPT_PATH+'/')
def srcDir = new File("$dirPath");
	if (srcDir.exists()) {
	 def trgtDir="$RWG_APPDATA/${dirName}/$PRODNAME/" 
	 println "NOTE::Source Directory :: $dirPath exists. Copying to RiskWorkGroup :: $trgtDir";
     println('')	 
	new AntBuilder().copy(todir: trgtDir) {
        fileset(dir : dirPath) 
        }

	}else {
		 println "Source Directory :: $dirPath doesn't exist. Nothing to copy to RWG";
	}

}
}
}else {
println("NOTE:No workgroups found in dir ::$RFW_APPDATA_WG_PATH.  Nothing to migrate.")
}
}else {
println("NOTE:You have no workgroups::"+ RFW_APPDATA_WG_PATH)
}



]]


--Creating temp file which proc groovy. 
local tmpfile=createTempFile(groovy,'endsubmit; \n quit; \n')
print(tmpfile)



sas.submit([[

%let metahost=@metahost@;
%let metaport=@metaport@ ;
%let metarepository=@metarepository@;
%let sasadmpass=@sasadmpass@;
%let solution12byte=@solution12byte@;
%let sasconflev=@sasconflev@;
%let rfw_prod_name=@rfw_prod_name@;
%let rfw_appdata=@rfw_appdata@;
%let rwg_appdata= @rwg_appdata@;
%let rwg_script_path=@rwg_script_path@;

%include "@tmpfile@";

]],{metahost=metahost,metaport=metaport,metarepository=metarepository,sasadmpass=sasadmpass,solution12byte=solution12byte,sasconflev=sasconflev,
rfw_prod_name=rfw_prod_name,rfw_appdata=rfw_appdata,rwg_appdata=rwg_appdata,rwg_script_path=rwg_script_path,
tmpfile=tmpfile},nil,4)




endsubmit;
run;

